grammar Expression;

options {
	language = Java;
}

/*
 * Auskommentieren, wenn beim ersten Fehler mit Exception abgebrochen werden soll.
 */
//@rulecatch {
//  catch (RecognitionException e) {
//    throw e;
//  }
//}

exprFile : expression EOF;

expression
  : token (('+' | '*' | '/') expression)?
  | '(' expression ')'
  ;
  
token
  : IDENTIFIER
  | INTEGER_LITERAL
  ;

fragment CHAR : ('a'..'z');
fragment DIGIT : ('0'..'9');
IDENTIFIER : CHAR+;
INTEGER_LITERAL : ('+' | '-')? (DIGIT)+;
WHITESPACE : (' ' | '\t' | '\r' | '\n' )+
  { skip(); }
;