import java.io.FileInputStream;
import java.io.IOException;

import org.antlr.runtime.ANTLRInputStream;
import org.antlr.runtime.CommonTokenStream;
import org.antlr.runtime.RecognitionException;
import org.antlr.runtime.Token;

public class Main {

	public static void main(String[] args) throws IOException,
			RecognitionException {
		String input = "examples/expr.txt";

		if (args.length > 0) {
			input = args[0];
		}

		FileInputStream in = new FileInputStream(input);
		ExpressionLexer lex = new ExpressionLexer(new ANTLRInputStream(in));
		
		Token tok = lex.nextToken();
		while (tok != Token.EOF_TOKEN) {
			System.out.println(tok);
			tok = lex.nextToken();
		}
		
		lex.reset();
		
		ExpressionParser parse = new ExpressionParser(
				new CommonTokenStream(lex));
		parse.exprFile();
		/*
		 * Auskommentieren, wenn man mit Exception beim ersten Fehler abbricht
		 * -> @rulecatch muss in der Grammatik aktiviert sein.
		 */
//		try {
//			parse.exprFile();
//		} catch (RecognitionException r) {
//			Token t = r.token;
//			System.out.println("Fehler in " + t.getLine() + "," + 
//					t.getCharPositionInLine() + ": " + t.getText());
//		}
	}

}
